<?php

namespace app\controllers\mikrotik\capsman;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\mikrotik\MikrotikSideMenu;
use yii\data\ArrayDataProvider;
use app\models\mikrotik\capsman\Provisioning;

class ProvisioningController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                    [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanCreateProvisioning'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanDeleteProvisioning'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanDisableProvisioning'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanEnableProvisioning'],
                    ], [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanUpdateProvisioning'],
                    ],
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionIndex() {
        $model = new Provisioning();
        return var_dump($model->getAll());
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Provisioning();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($_POST['Provisioning']['hw_supported_modes'] != '') {
                $opt = implode(",", $_POST['Provisioning']['hw_supported_modes']);
                $model->hw_supported_modes = $opt;
            }
            if ($_POST['Provisioning']['slave_configurations'] != '') {
                $opt = implode(",", $_POST['Provisioning']['slave_configurations']);
                $model->slave_configurations = $opt;
            }
            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
            }
        } else {
            $model->get($id);
        }
        $model->hw_supported_modes = explode(',', $model->hw_supported_modes);
        $model->slave_configurations = explode(',', $model->slave_configurations);
        return $this->render('/mikrotik/capsman/provisioning', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
                    'items' => $model->getConfig(),
        ]);
    }

    public function actionCreate() {
        $menu = new MikrotikSideMenu();
        $model = new Provisioning();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($_POST['Provisioning']['hw_supported_modes'] != '') {
                $opt = implode(",", $_POST['Provisioning']['hw_supported_modes']);
                $model->hw_supported_modes = $opt;
            }
            if ($_POST['Provisioning']['slave_configurations'] != '') {
                $opt = implode(",", $_POST['Provisioning']['slave_configurations']);
                $model->slave_configurations = $opt;
            }
            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
            }
        }

        return $this->render('/mikrotik/capsman/provisioning', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
                    'items' => $model->getConfig(),
        ]);
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Provisioning();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Provisioning();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Provisioning();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

}
